#!/usr/bin/perl -T

# "noc-dev-if-perdev.pl"
# Copyright (c) 2006 Sasa Dautovic - Sveucilisni Racunski Centar (SRCE) 
#
# Author:  
#	  Sasa Dautovic <Sasa.Dautovic@srce.hr>
#  
# Feel free to email me at Sasa.Dautovic@srce.hr for any questions, suggestions 
# regarding this software.  
# 
# Sveucilisni Racunski Centar (SRCE) 
# Ulica Josipa Marohnica 5
# 10000 Zagreb
# Croatia
# 
# All rights reserved.
#

use SNMP_Session;
use SNMP_util;
use DBI();
use Switch;
use Sys::Syslog;

sub getInvDevIFDesc {		# $db, $DevID, $ifDesc
	my $db = @_[0];
	my $dev = @_[1];
	my $ifDesc = @_[2];
	
	@out = '';
	
	my $sql = "SELECT descID, ifIndex, ifDesc, ifType, ifMTU, ifSpeed, ifPhysAddr, ifAdminStatus, ifOperStatus, ifLastChange FROM `InvDevIntDesc` WHERE devID='".$dev."' AND ifDesc='".$ifDesc."'";
	my $thDesc = $db->prepare($sql);
	$thDesc->execute();

	@out = $thDesc->fetchrow_array;
	$thDesc->finish();
	
	return @out;
}

sub getInvDevIFTraffic {	# $db, $DevID, $ifDesc
	my $db = @_[0];
	my $dev = @_[1];
	my $ifDesc = @_[2];
	
	@out = '';
	
	my $sql = "SELECT A.trafficID, A.ifInOctets, A.ifInUcastPkts, A.ifInNUcastPkts, A.ifInDiscards,".
	          " A.ifInErrors, A.ifInUnknownProtos, A.ifOutOctets, A.ifOutUcastPkts, A.ifOutNUcastPkts, A.ifOutDiscards,".
	          " A.ifOutErrors, A.ifOutQLen FROM `InvDevIntTraffic` A, `InvDevInt` B WHERE B.devID=A.devID AND A.intID=B.intID AND A.devID='".$dev."' AND B.ifDesc='".$ifDesc."'";
	my $thDesc = $db->prepare($sql);
	$thDesc->execute();

	@out = $thDesc->fetchrow_array;
	$thDesc->finish();
	
	return @out;
}

# configuration file
$configFile="/etc/noc-mon-studom/config.pl";

openlog('noc-dev-if-perdev.pl', 'pid', LOG_SYSLOG);

# import variables from config file if one exists
if( -f $configFile ) {
	require ($configFile);
	$log = sprintf("Loaded config from %s", $configFile);
	syslog(LOG_INFO, $log);
} else { $log = sprintf("Unable to load config file %s",$configFile); syslog(LOG_INFO, $log); exit(1); }

$table_oid='1.3.6.1.2.1.2.2';

my $i=0; 
my $desc=''; 
my $oid=0;

my $startID = 0;
my $stopID = 0;

my @IPaddr = ();
my @comm = ();
my @devID = ();

my $intID = '';

my $data=DBI->connect("DBI:mysql:database=$database;host=$hostdb",$user,$pass);

$sql="SELECT IPaddr, community, devID FROM InvDev WHERE active='1' AND SNMP='1' ORDER BY devID";
my $th=$data->prepare($sql);
$th->execute();

while (@red_u = $th->fetchrow_array) {
	push(@IPaddr, $red_u[0]);
	push(@comm, $red_u[1]);
	push(@devID, $red_u[2]);
}

my $selectedDev = scalar(@IPaddr);

for ($t = 0; $t < $selectedDev; $t++) {

		@ifIndex = '';
		@ifDesc = '';
		@ifType = '';
		@ifMTU = '';
		@ifSpeed = '';
		@ifPhysAddr = '';
		@ifAdminStatus = '';
		@ifOperStatus = '';
		@ifLastChange = '';

		@ifInOctets = '';
		@ifInUcastPkts = '';
		@ifInNUcastPkts = '';
		@ifInDiscards = '';
		@ifInErrors = '';
		@ifInUnknownProtos = '';
		@ifOutOctets = '';
		@ifOutUcastPkts = '';
		@ifOutNUcastPkts = '';
		@ifOutDiscards = '';
		@ifOutErrors = '';
		@ifOutQLen = '';
  
	 		my $host=$IPaddr[$t];
   		my $community=$comm[$t];
   		my $port=161;
   
   		@out = &snmpwalk($community."@".$host.":".$port, $table_oid);
   
   		$r = @out / 22;		# 22 - defines number of columns that this OID returns
	 
   		$pos = 0;
   		foreach $value (@out) {
   	  
      		@D = split(':', $value, 2);
      		$attrib = int($pos / $r);
     
      		switch ($attrib) {
      			case 0		{ push(@ifIndex, @D[1]); }
      			case 1		{ push(@ifDesc, @D[1]); }
      			case 2		{ push(@ifType, @D[1]); }
      			case 3		{ push(@ifMTU, @D[1]); }
      			case 4		{ push(@ifSpeed, @D[1]); }
      			case 5		{ @H = unpack("%H*", @D[1]); 
      		    		      $Hstr = "@H[0]";	# Ovo izvuce HEX string u pravi Perl string
      		       		   	  push(@ifPhysAddr, $Hstr); 
      		        		}
      			case 6		{ push(@ifAdminStatus, @D[1]); }
      			case 7		{ push(@ifOperStatus, @D[1]); }
      			case 8		{ $S = sprintf("%s", @D[1]);
      						  push(@ifLastChange, $S); 
      						}
      			case 9		{ push(@ifInOctets, @D[1]); }
      			case 10		{ push(@ifInUcastPkts, @D[1]); }
      			case 11		{ push(@ifInNUcastPkts, @D[1]); }
      			case 12		{ push(@ifInDiscards, @D[1]); }
      			case 13		{ push(@ifInErrors, @D[1]); }
      			case 14		{ push(@ifInUnknownProtos, @D[1]); }
      			case 15		{ push(@ifOutOctets, @D[1]); }
      			case 16		{ push(@ifOutUcastPkts, @D[1]); }
      			case 17		{ push(@ifOutNUcastPkts, @D[1]); }
      			case 18 	{ push(@ifOutDiscards, @D[1]); }
      			case 19		{ push(@ifOutErrors, @D[1]); }
      			case 20		{ push(@ifOutQLen, @D[1]); }
      		}
   	  		$pos = $pos + 1;
   		}
   
   		for ($k = 1; $k <= $r; $k++) {
   		
   			$dataStr = $ifIndex[$k].$ifDesc[$k].$ifType[$k].$ifMTU[$k].$ifSpeed[$k].$ifPhysAddr[$k].$ifAdminStatus[$k].$ifOperStatus[$k].$ifLastChange[$k];
   			$trafficStr = $ifInOctets[$k].$ifInUcastPkts[$k].$ifInNUcastPkts[$k].$ifInDiscards[$k].$ifInErrors[$k].$ifInUnknownProtos[$k].$ifOutOctets[$k].$ifOutUcastPkts[$k].$ifOutNUcastPkts[$k].$ifOutDiscards[$k].$ifOutErrors[$k].$ifOutQLen[$k];
   		
   			# Dohvatim zadnje vrijednosti iz Desc tablice i procesiram detekciju promjena i unosa promjena u 
   			# history tablicu kao i aktivnu tablicu.
   			@dataRec = getInvDevIFDesc($data, $devID[$t], $ifDesc[$k]);
   			if (@dataRec == 0) {
   				  $log = sprintf("InsertInto(InvDevInt): DevID: %s, ifDesc: %s", $devID[$t], $ifDesc[$k]); 
				  syslog(LOG_INFO, $log);

				  $sql = "INSERT INTO `InvDevInt` (intID, devID, ifDesc) VALUES ('', '".$devID[$t]."', '".$ifDesc[$k]."')";	
					$thRec = $data->prepare($sql);
					$thRec->execute();
					# $intID = $thRec->last_insert_id();
					$intID = $thRec->{'mysql_insertid'};
					$thRec->finish();

   				$log = sprintf("InsertInto(InvDevIntDesc): DevID: %s, ifIndex: %s, ifDesc: %s", $devID[$t], $ifIndex[$k], $ifDesc[$k]); 
				syslog(LOG_INFO, $log);
   				$sql = "INSERT INTO `InvDevIntDesc` (descID, intID, devID, ifIndex, ifDesc, ifType, ifMTU, ifSpeed, ifPhysAddr, ifAdminStatus, ifOperStatus, ifLastChange) VALUES ".
   				   "('', '".$intID."', '".$devID[$t]."', '".$ifIndex[$k]."', '".$ifDesc[$k]."', '".$ifType[$k]."', '".$ifMTU[$k]."', '".$ifSpeed[$k]."', '".$ifPhysAddr[$k]."', ".
   				   "'".$ifAdminStatus[$k]."', '".$ifOperStatus[$k]."', '".$ifLastChange[$k]."')";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', 
   			         '".$intID."', '".$devID."', 'ifType', '".$ifType[$k]."', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', 
   			         '".$intID."', '".$devID."', 'ifMTU', '".$ifMTU[$k]."', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', 
   			         '".$intID."', '".$devID."', 'ifSpeed', '".$ifSpeed[$k]."', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', 
   			         '".$intID."', '".$devID."', 'ifPhysAddr', '".$ifPhysAddr[$k]."', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', 
   			         '".$intID."', '".$devID."', 'ifAdminStatus', '".$ifAdminStatus[$k]."', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', 
   			         '".$intID."', '".$devID."', 'ifOperStatus', '".$ifOperStatus[$k]."', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', 
   			         '".$intID."', '".$devID."', 'ifLastChange', '".$ifLastChange[$k]."', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();		
   			} else {
   				$dataRecStr = $dataRec[1].$dataRec[2].$dataRec[3].$dataRec[4].$dataRec[5].$dataRec[6].$dataRec[7].$dataRec[8].$dataRec[9];

   				if ($dataRecStr ne $dataStr) {
   					
   					$sql = "UPDATE `InvDevIntDesc` SET ifIndex='".$ifIndex[$k]."', ifDesc='".$ifDesc[$k]."', ifType='".$ifType[$k]."', ".
   					       "ifMTU='".$ifMTU[$k]."', ifSpeed='".$ifSpeed[$k]."', ifPhysAddr='".$ifPhysAddr[$k]."', ifAdminStatus='".$ifAdminStatus[$k]."', ".
   					       "ifOperStatus='".$ifOperStatus[$k]."', ifLastChange='".$ifLastChange[$k]."' WHERE descID='".$dataRec[0]."'";
   					$thRec = $data->prepare($sql);
   					$thRec->execute();
   					$thRec->finish();
   				
   				
   					if ($ifType[$k] != $dataRec[4]) {
   						$log = sprintf("UpdateDesc: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifType", $ifType[$k]); 
							syslog(LOG_INFO, $log);
   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', '".$dataRec[0]."', '".$devID[$t]."', 
   			       		   'ifType', '".$ifType[$k]."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifMTU[$k] != $dataRec[5]) {
   						$log = sprintf("UpdateDesc: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifMTU", $ifMTU[$k]); 
							syslog(LOG_INFO, $log);
   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', '".$dataRec[0]."', '".$devID[$t]."', 
   			       		   'ifMTU', '".$ifMTU[$k]."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifSpeed[$k] != $dataRec[6]) {
   						$log = sprintf("UpdateDesc: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifSpeed", $ifMTU[$k]); 
							syslog(LOG_INFO, $log);
   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', '".$dataRec[0]."', '".$devID[$t]."', 
   			       		   'ifSpeed', '".$ifSpeed[$k]."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifPhysAddr[$k] != $dataRec[7]) {
   						$log = sprintf("UpdateDesc: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifPhysAddr", $ifPhysAddr[$k]); 
							syslog(LOG_INFO, $log);
   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', '".$dataRec[0]."', '".$devID[$t]."', 
   			       		   'ifPhysAddr', '".$ifPhysAddr[$k]."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifAdminStatus[$k] != $dataRec[8]) {
   						$log = sprintf("UpdateDesc: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifAdminStatus", $ifAdminStatus[$k]); 
							syslog(LOG_INFO, $log);
   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', '".$dataRec[0]."', '".$devID[$t]."', 
   			       		   'ifAdminStatus', '".$ifAdminStatus[$k]."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifOperStatus[$k] != $dataRec[9]) {
   						$log = sprintf("UpdateDesc: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifOperStatus", $ifOperStatus[$k]); 
							syslog(LOG_INFO, $log);
   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', '".$dataRec[0]."', '".$devID[$t]."', 
   			       		   'ifOperStatus', '".$ifOperStatus[$k]."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifLastChange[$k] != $dataRec[10]) {
   						$log = sprintf("UpdateDesc: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifLastChange", $ifLastChange[$k]); 
							syslog(LOG_INFO, $log);
   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ('', '".$dataRec[0]."', '".$devID[$t]."', 
   			       		   'ifLastChange', '".$ifLastChange[$k]."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				}
   			}
   		
   			@trafficRec = getInvDevIFTraffic($data, $devID[$t], $ifDesc[$k]);
   			if (@trafficRec == 0) {
   				$log = sprintf("InsertInto(InvDevIntTraffic): DevID: %s, ifDesc: %s", $devID[$t], $ifDesc[$k]);
					syslog(LOG_INFO, $log);
   				$sql = "INSERT INTO `InvDevIntTraffic` (trafficID, intID, devID, ifInOctets, ifInUcastPkts, ifInNUcastPkts, ifInDiscards,".
	          		" ifInErrors, ifInUnknownProtos, ifOutOctets, ifOutUcastPkts, ifOutNUcastPkts, ifOutDiscards, ifOutErrors, ifOutQLen) VALUES".
	          		" ('', '".$intID."', '".$devID[$t]."', '".$ifInOctets[$k]."', '".$ifInUcastPkts[$k]."',". 
	          		" '".$ifInNUcastPkts[$k]."', '".$ifInDiscards[$k]."', '".$ifInErrors[$k]."', '".$ifInUnknownProtos[$k]."',".
	          		" '".$ifOutOctets[$k]."', '".$ifOutUcastPkts[$k]."', '".$ifOutNUcastPkts[$k]."', '".$ifOutDiscards[$k]."',".
	          		" '".$ifOutErrors[$k]."', '".$ifOutQLen[$k]."')";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifInOctets', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifInUcastPkts', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifInNUcastPkts', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifInDiscards', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifInErrors', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifInUnknownProtos', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifOutOctets', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifOutUcastPkts', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifOutNUcastPkts', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifOutDiscards', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifOutErrors', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			
   				$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES (
   			   	     '', '".$intID."', '".$devID[$t]."', 'ifOutQLen', '0', NOW())";
   				$thRec = $data->prepare($sql);
   				$thRec->execute();
   				$thRec->finish();
   			} else {
   				$trafficRecStr = $trafficRec[1].$trafficRec[2].$trafficRec[3].$trafficRec[4].$trafficRec[5].$trafficRec[6].
   							 $trafficRec[7].$trafficRec[8].$trafficRec[9].$trafficRec[10].$trafficRec[11].$trafficRec[12].
   							 $trafficRec[13];

   				if ($trafficRecStr ne $trafficStr) {
   			
   					$sql = "UPDATE `InvDevIntTraffic` SET ifInOctets='".$ifInOctets[$k]."', ".
						        "ifInUcastPkts='".$ifInUcastPkts[$k]."', ifInNUcastPkts='".$ifInNUcastPkts[$k]."', ifInDiscards='".$ifInDiscards[$k]."', ".
   					       "ifInErrors='".$ifInErrors[$k]."', ifInUnknownProtos='".$ifInUnknownProtos[$k]."', ifOutOctets='".$ifOutOctets[$k]."', ".
   					       "ifOutUcastPkts='".$ifOutUcastPkts[$k]."', ifOutNUcastPkts='".$ifOutNUcastPkts[$k]."', ifOutDiscards='".$ifOutDiscards[$k]."', ".
   					       "ifOutErrors='".$ifOutErrors[$k]."', ifOutQLen='".$ifOutQLen[$k]."' WHERE trafficID='".$trafficRec[0]."'";
   					$thRec = $data->prepare($sql);
   					$thRec->execute();
   					$thRec->finish();
   				
   					if ($ifInOctets[$k] != $trafficRec[4]) {
   					
   						my $diff = 0;
   						if ($ifInOctets[$k] >= $trafficRec[4]) { $diff = $ifInOctets[$k] - $trafficRec[4]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifInOctets", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifInOctets', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifInUcastPkts[$k] != $trafficRec[5]) {
   					
   						my $diff = 0;
   						if ($ifInUcastPkts[$k] >= $trafficRec[5]) { $diff = $ifInUcastPkts[$k] - $trafficRec[5]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifInUcastPkts", $diff); 
							syslog(LOG_INFO, $log);
   					
   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifInUcastPkts', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifInNUcastPkts[$k] != $trafficRec[6]) {
   					
   						my $diff = 0;
   						if ($ifInNUcastPkts[$k] >= $trafficRec[6]) { $diff = $ifInNUcastPkts[$k] - $trafficRec[6]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifInNUcastPkts", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifInNUcastPkts', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifInDiscards[$k] != $trafficRec[7]) {
   					
   						my $diff = 0;
   						if ($ifInDiscards[$k] >= $trafficRec[7]) { $diff = $ifInDiscards[$k] - $trafficRec[7]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifInDiscards", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifInDiscards', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();	
   					}
   				
   					if ($ifInErrors[$k] != $trafficRec[8]) {
   					
   						my $diff = 0;
   						if ($ifInErrors[$k] >= $trafficRec[8]) { $diff = $ifInErrors[$k] - $trafficRec[8]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifInErrors", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifInErrors', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifInUnknownProtos[$k] != $trafficRec[9]) {
   					
   						my $diff = 0;
   						if ($ifInUnknownProtos[$k] >= $trafficRec[9]) { $diff = $ifInUnknownProtos[$k] - $trafficRec[9]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifInUnknownProtos", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifUnknownProtos', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifOutOctets[$k] != $trafficRec[10]) {
   					
   						my $diff = 0;
   						if ($ifOutOctets[$k] >= $trafficRec[10]) { $diff = $ifOutOctets[$k] - $trafficRec[10]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifOutOctets", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifOutOctets', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();	
   					}
   				
   					if ($ifOutUcastPkts[$k] != $trafficRec[11]) {
   					
   						my $diff = 0;
   						if ($ifOutUcastPkts[$k] >= $trafficRec[11]) { $diff = $ifOutUcastPkts[$k] - $trafficRec[11]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifOutUcastPkts", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifOutUcastPkts', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifOutNUcastPkts[$k] != $trafficRec[12]) {
   					
   						my $diff = 0;
   						if ($ifOutNUcastPkts[$k] >= $trafficRec[12]) { $diff = $ifOutNUcastPkts[$k] - $trafficRec[12]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifOutNUcastPkts", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifOutNUcastPkts', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifOutDiscards[$k] != $trafficRec[13]) {
   					
   						my $diff = 0;
   						if ($ifOutDiscards[$k] >= $trafficRec[13]) { $diff = $ifOutDiscards[$k] - $trafficRec[13]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifOutDiscards", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifOutDiscards', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				
   					if ($ifOutErrors[$k] != $trafficRec[14]) {
   					
   						my $diff = 0;
   						if ($ifOutErrors[$k] >= $trafficRec[14]) { $diff = $ifOutErrors[$k] - $trafficRec[14]; }
   						else { $diff = -1; }
   					
   					  $log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifOutErrors", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifOutErrors', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();	
   					}
   				
   					if ($ifOutQLen[$k] != $trafficRec[15]) {
   					
   						my $diff = 0;
   						if ($ifOutQLen[$k] >= $trafficRec[15]) { $diff = $ifOutQLen[$k] - $trafficRec[15]; }
   						else { $diff = -1; }
   					
   						$log = sprintf("UpdateTraffic: DevID: %s, ifDesc: %s, field: %s, value: %s", $devID[$t], $ifDesc[$k], "ifOutQLen", $diff); 
							syslog(LOG_INFO, $log);

   						$sql = "INSERT INTO `InvDevIntHistory` (historyID, intID, devID, field, value, timestamp) VALUES ( 
   			       		   '', '".$trafficRec[0]."', '".$devID[$t]."', 'ifOutQLen', '".$diff."', NOW())";
   						$thRec = $data->prepare($sql);
   						$thRec->execute();
   						$thRec->finish();
   					}
   				}
   			}
   		} # kraj FOR petlje 
} # kraj main FOR petlje

$th->finish;
$data->disconnect();

closelog();
exit(1);
