#!/usr/bin/perl -T

# "noc-dev-snmp-daemon.pl"
# Copyright (c) 2006 Sasa Dautovic - Sveucilisni Racunski Centar (SRCE) 
#
# Author:  
#	  Sasa Dautovic <Sasa.Dautovic@srce.hr>
#  
# Feel free to email me at Sasa.Dautovic@srce.hr for any questions, suggestions 
# regarding this software.  
# 
# Sveucilisni Racunski Centar (SRCE) 
# Ulica Josipa Marohnica 5
# 10000 Zagreb
# Croatia
# 
# All rights reserved.
#

use SNMP_Session;
use SNMP_util;
use DBI();
use Switch;
use Sys::Syslog;

# configuration file
$configFile="/etc/noc-mon-studom/config.pl";

openlog('noc-mon-studom.pl', 'pid', LOG_SYSLOG);

# import variables from config file if one exists
if( -f $configFile ) {
	require ($configFile);
	$log = sprintf("Loaded config from $configFile");
	syslog(LOG_INFO, $log);
} else { $log = sprintf("Unable to load config file $configFile"); syslog(LOG_INFO, $log); exit(1); }

$OID = '1.3.6.1.2.1.1.1';
$port = 161;

my @IPaddr = ();
my @comm = ();
my @devID = ();
my @children = ();

my $data=DBI->connect("DBI:mysql:database=$database;host=$hostdb",$user,$pass);

$sql = "SHOW TABLES LIKE 'InvDevHistory'";
my $th = $data->prepare($sql);
$th->execute();
@rec = $th->fetchrow_array;
$th->finish();

$s = scalar(@rec);
if ($s == 0) {
	$sql = "CREATE TABLE `InvDevHistory` (
	        `historyID` bigint(20) NOT NULL auto_increment,
		      `devID` int(4) default NULL,
			    `field` char(64) default NULL,
				  `value` char(96) default NULL,
					`timestamp` timestamp NULL default NULL,
					PRIMARY KEY  (`historyID`)
					) ENGINE=MyISAM DEFAULT CHARSET=latin2;";
	my $th = $data->prepare($sql);
	$th->execute();
	$th->finish();
}

$sql="SELECT IPaddr, community, devID FROM InvDev WHERE active <> '2'";
my $th=$data->prepare($sql);
$th->execute();
while (@row = $th->fetchrow_array) {
	push(@IPaddr, $row[0]);
	push(@comm, $row[1]);
	push(@devID, $row[2]);
}
$th->finish;
$data->disconnect();

my $size = scalar(@IPaddr);

for ($iterator = 0; $iterator < $size; $iterator++) {
	
	$PID = fork;
	my $host = $IPaddr[$iterator];
	my $community = $comm[$iterator];
	
	if ($PID == 0) {	# Do the child process

		@out = '';
		@out = &snmpwalk($community."@".$host.":".$port, $OID);
		
		my $data=DBI->connect("DBI:mysql:database=$database;host=$hostdb",$user,$pass);

		if ($out[0] eq '') {
			
			$log = sprintf("DevID = %d changed SNMP status = 0", $devID[$iterator]);
		  syslog(LOG_INFO, $log);

			$sql = "UPDATE InvDev SET SNMP='0' WHERE devID='".$devID[$iterator]."'"; 
			my $th = $data->prepare($sql);
			$th->execute();
			$th->finish();
		  
			@recT = '';
			$sql = "SELECT active FROM InvDev WHERE devID='".$devID[$iterator]."'";
			my $th = $data->prepare($sql);
			$th->execute();
			@recT = $th->fetchrow_array;
			$th->finish();
			
			$sql = "UPDATE InvDev SET active='0' WHERE devID='".$devID[$iterator]."'";
			my $th = $data->prepare($sql);
			$th->execute();
			$th->finish();
		
			if ($recT[0] != 0) {
				$sql = "INSERT INTO InvDevHistory (historyID, devID, field, value, timestamp) VALUES ('','".$devID[$iterator]."', 'active', '0', NOW())";
				my $th = $data->prepare($sql);
				$th->execute();
				$th->finish();
			} 
			
		} else {

			$log = sprintf("DevID = %d changed SNMP status = 1", $devID[$iterator]);
		  syslog(LOG_INFO, $log);

			$sql = "UPDATE InvDev SET SNMP='1' WHERE devID='".$devID[$iterator]."'"; 
			my $th = $data->prepare($sql);
			$th->execute();
			$th->finish();
			
			@recT = '';
			$sql = "SELECT active FROM InvDev WHERE devID='".$devID[$iterator]."'";
			my $th = $data->prepare($sql);
			$th->execute();
			@recT = $th->fetchrow_array;
			$th->finish();
			
			$sql = "UPDATE InvDev SET active='1' WHERE devID='".$devID[$iterator]."'";
			my $th = $data->prepare($sql);
			$th->execute();
			$th->finish();
			
			if ($recT[0] != 1) {
				$sql = "INSERT INTO InvDevHistory (historyID, devID, field, value, timestamp) VALUES ('','".$devID[$iterator]."', 'active', '1', NOW())";
				my $th = $data->prepare($sql);
				$th->execute();
				$th->finish();
			}
		}

		$data->disconnect();
		exit;	# exiting the child
	}
	push(@children, $PID);
}

my $childnum = scalar(@children);
for ($p = 1; $p <= $childnum; $p++) { waitpid(@children[$p-1], 0); }
for ($p = 1; $p <= $childnum; $p++) { pop(@children); }

closelog();
